/*
 *  tool_pragmas.h version 8.1 -  Copyright 1990 Jaba Development
 *
 *  Author : Jan van den Baard
 *
 *  tool.library pragmas for inline calls.
 */

#ifndef TOOL_PRAGMAS_H
#define TOOL_PRAGMAS_H

#ifndef TOOL_H
#include <tool.h>
#endif

#ifdef AZTEC_C
#pragma amicall(ToolBase, 0x1e, CreatePort(a0,d0))
#pragma amicall(ToolBase, 0x24, DeletePort(a0))
#pragma amicall(ToolBase, 0x2a, CreateExtIO(a0,d0))
#pragma amicall(ToolBase, 0x30, DeleteExtIO(a0))
#pragma amicall(ToolBase, 0x36, CreateStdIO(a0))
#pragma amicall(ToolBase, 0x3c, DeleteStdIO(a0))
#pragma amicall(ToolBase, 0x42, CreateTimeDelay(a0,d0,d1))
#pragma amicall(ToolBase, 0x48, DoTimeDelay(a0))
#pragma amicall(ToolBase, 0x4e, DeleteTimeDelay(a0))
#pragma amicall(ToolBase, 0x54, QuickSort(a0,d0,d1,a1))
#pragma amicall(ToolBase, 0x5a, SwapMem(a0,a1,d1))
#pragma amicall(ToolBase, 0x60, TestBits(d0,d1))
#pragma amicall(ToolBase, 0x66, SelectGadget(a0,a1,a2))
#pragma amicall(ToolBase, 0x6c, DeSelectGadget(a0,a1,a2))
#pragma amicall(ToolBase, 0x72, MutualExclude(a0,a1,a2,a3))
#pragma amicall(ToolBase, 0x78, MutualInclude(a0,a1,a2,a3))
#pragma amicall(ToolBase, 0x7e, EraseGadget(a0,a1,a2))
#pragma amicall(ToolBase, 0x84, GadgetOn(a0,a1,a2))
#pragma amicall(ToolBase, 0x8a, GadgetOff(a0,a1,a2))
#pragma amicall(ToolBase, 0x90, SelectTest(a0))
#pragma amicall(ToolBase, 0x96, ShadowGadget(a0,a1,a2,d0))
#pragma amicall(ToolBase, 0x9c, OnGList(a0,a1,a2,d0))
#pragma amicall(ToolBase, 0xa2, OffGList(a0,a1,a2,d0))
#pragma amicall(ToolBase, 0xa8, SelectGList(a0,a1,a2,d0))
#pragma amicall(ToolBase, 0xae, DeSelectGList(a0,a1,a2,d0))
#pragma amicall(ToolBase, 0xb4, ShadowGList(a0,a1,a2,d0,d1))
#pragma amicall(ToolBase, 0xba, EraseGList(a0,a1,a2,d0))
#pragma amicall(ToolBase, 0xc0, InitMemoryChain(a0,d0))
#pragma amicall(ToolBase, 0xc6, AllocItem(a0,d0,d1))
#pragma amicall(ToolBase, 0xcc, FreeItem(a0,a1,d0))
#pragma amicall(ToolBase, 0xd2, FreeMemoryChain(a0))
/*----------------------------------------------------------------*
 * These two are only available through the linker library !      *
 *                                                                *
 * #pragma amicall(ToolBase, 0xd8, Format(a0,a1,a2))              *
 * #pragma amicall(ToolBase, 0xde, WriteFormat(a0,a1,a2))         *
 *----------------------------------------------------------------*/
#pragma amicall(ToolBase, 0xe4, MatchPattern(a0,a1,d0))
#pragma amicall(ToolBase, 0xea, Isolate(a0,a1))
#pragma amicall(ToolBase, 0xf0, BstrToCstr(a0,a1))
#pragma amicall(ToolBase, 0xf6, GetDate(a0,a1,d0))
#pragma amicall(ToolBase, 0xfc, OpenDir(a0,a1))
#pragma amicall(ToolBase, 0x102, GetEntry(a0))
#pragma amicall(ToolBase, 0x108, CloseDir(a0))
#pragma amicall(ToolBase, 0x10e, FreeDir(a0))
#pragma amicall(ToolBase, 0x114, IoErrToStr())
#pragma amicall(ToolBase, 0x11a, AllocFreq())
#pragma amicall(ToolBase, 0x120, FreeFreq(a0))
#pragma amicall(ToolBase, 0x126, FileRequest(a0))
/*----------------------------------------------------------------*
 * This one is only available through the linker library !        *
 *                                                                *
 * #pragma amicall(ToolBase, 0x12c, FormatText(a0,a1,a2))         *
 *----------------------------------------------------------------*/
#else
#pragma libcall ToolBase CreatePort 1E 802
#pragma libcall ToolBase DeletePort 24 801
#pragma libcall ToolBase CreateExtIO 2A 802
#pragma libcall ToolBase DeleteExtIO 30 801
#pragma libcall ToolBase CreateStdIO 36 801
#pragma libcall ToolBase DeleteStdIO 3C 801
#pragma libcall ToolBase CreateTimeDelay 42 10803
#pragma libcall ToolBase DoTimeDelay 48 801
#pragma libcall ToolBase DeleteTimeDelay 4E 801
#pragma libcall ToolBase QuickSort 54 910804
#pragma libcall ToolBase SwapMem 5A 19803
#pragma libcall ToolBase TestBits 60 1002
#pragma libcall ToolBase SelectGadget 66 A9803
#pragma libcall ToolBase DeSelectGadget 6C A9803
#pragma libcall ToolBase MutualExclude 72 BA9804
#pragma libcall ToolBase MutualInclude 78 BA9804
#pragma libcall ToolBase EraseGadget 7E A9803
#pragma libcall ToolBase GadgetOn 84 A9803
#pragma libcall ToolBase GadgetOff 8A A9803
#pragma libcall ToolBase SelectTest 90 801
#pragma libcall ToolBase ShadowGadget 96 A9804
#pragma libcall ToolBase OnGList 9C A9804
#pragma libcall ToolBase OffGList A2 A9804
#pragma libcall ToolBase SelectGList A8 A9804
#pragma libcall ToolBase DeSelectGList AE A9804
#pragma libcall ToolBase ShadowGList B4 10A9805
#pragma libcall ToolBase EraseGList BA A9804
#pragma libcall ToolBase InitMemoryChain C0 802
#pragma libcall ToolBase AllocItem C6 10803
#pragma libcall ToolBase FreeItem CC 9803
#pragma libcall ToolBase FreeMemoryChain D2 801
#pragma libcall ToolBase Format D8 A9803
/*----------------------------------------------------------------*
 * These two are only available through the linker library !      *
 *                                                                *
 * #pragma libcall ToolBase WriteFormat DE A9803                  *
 * #pragma libcall ToolBase MatchPattern E4 9803                  *
 *----------------------------------------------------------------*/
#pragma libcall ToolBase Isolate EA 9802
#pragma libcall ToolBase BstrToCstr F0 9802
#pragma libcall ToolBase GetDate F6 9803
#pragma libcall ToolBase OpenDir FC 9802
#pragma libcall ToolBase GetEntry 102 801
#pragma libcall ToolBase CloseDir 108 801
#pragma libcall ToolBase FreeDir 10E 801
#pragma libcall ToolBase IoErrToStr 114 0
#pragma libcall ToolBase AllocFreq 11A 0
#pragma libcall ToolBase FreeFreq 120 801
#pragma libcall ToolBase FileRequest 126 801
/*----------------------------------------------------------------*
 * This one is only available through the linker library !        *
 *                                                                *
 * #pragma libcall ToolBase FormatText 12C A9803                  *
 *----------------------------------------------------------------*/
#endif
#endif

